
-- --------------------------------------------------
-- Entity Designer DDL Script for SQL Server 2005, 2008, and Azure
-- --------------------------------------------------
-- Date Created: 06/05/2012 20:27:59
-- Generated from EDMX file: C:\Users\Roi\Documents\Visual Studio 2010\Projects\HouseKeeping\Yahalom\YPHouseKeepingRK\HouseKeeping\DataModels\HouseKeepingDBModel.edmx
-- --------------------------------------------------

SET QUOTED_IDENTIFIER OFF;
GO
USE [Housekeeping_MALAM];
GO
IF SCHEMA_ID(N'dbo') IS NULL EXECUTE(N'CREATE SCHEMA [dbo]');
GO

-- --------------------------------------------------
-- Dropping existing FOREIGN KEY constraints
-- --------------------------------------------------

IF OBJECT_ID(N'[dbo].[FK_ActionTypeIncome]', 'F') IS NOT NULL
    ALTER TABLE [dbo].[Incomes] DROP CONSTRAINT [FK_ActionTypeIncome];
GO
IF OBJECT_ID(N'[dbo].[FK_ActionTypeOutcome]', 'F') IS NOT NULL
    ALTER TABLE [dbo].[Outcomes] DROP CONSTRAINT [FK_ActionTypeOutcome];
GO
IF OBJECT_ID(N'[dbo].[FK_UsersIncome]', 'F') IS NOT NULL
    ALTER TABLE [dbo].[Incomes] DROP CONSTRAINT [FK_UsersIncome];
GO
IF OBJECT_ID(N'[dbo].[FK_UsersOutcome]', 'F') IS NOT NULL
    ALTER TABLE [dbo].[Outcomes] DROP CONSTRAINT [FK_UsersOutcome];
GO
IF OBJECT_ID(N'[dbo].[FK_UserTypesUsers]', 'F') IS NOT NULL
    ALTER TABLE [dbo].[Users] DROP CONSTRAINT [FK_UserTypesUsers];
GO

-- --------------------------------------------------
-- Dropping existing tables
-- --------------------------------------------------

IF OBJECT_ID(N'[dbo].[ActionTypes]', 'U') IS NOT NULL
    DROP TABLE [dbo].[ActionTypes];
GO
IF OBJECT_ID(N'[dbo].[Incomes]', 'U') IS NOT NULL
    DROP TABLE [dbo].[Incomes];
GO
IF OBJECT_ID(N'[dbo].[Outcomes]', 'U') IS NOT NULL
    DROP TABLE [dbo].[Outcomes];
GO
IF OBJECT_ID(N'[dbo].[Users]', 'U') IS NOT NULL
    DROP TABLE [dbo].[Users];
GO
IF OBJECT_ID(N'[dbo].[UserTypes]', 'U') IS NOT NULL
    DROP TABLE [dbo].[UserTypes];
GO

-- --------------------------------------------------
-- Creating all tables
-- --------------------------------------------------

-- Creating table 'ActionTypes'
CREATE TABLE [dbo].[ActionTypes] (
    [Id] int IDENTITY(1,1) NOT NULL,
    [Type] nvarchar(max)  NOT NULL,
    [Kind] nvarchar(max)  NOT NULL
);
GO

-- Creating table 'Incomes'
CREATE TABLE [dbo].[Incomes] (
    [Id] int IDENTITY(1,1) NOT NULL,
    [UsersId] int  NOT NULL,
    [Date] datetime  NOT NULL,
    [Amount] decimal(18,0)  NOT NULL,
    [Comment] nvarchar(max)  NOT NULL,
    [ActionTypeId] int  NOT NULL
);
GO

-- Creating table 'Outcomes'
CREATE TABLE [dbo].[Outcomes] (
    [Id] int IDENTITY(1,1) NOT NULL,
    [UsersId] int  NOT NULL,
    [Date] datetime  NOT NULL,
    [Amount] decimal(18,0)  NOT NULL,
    [Comment] nvarchar(max)  NOT NULL,
    [ActionTypeId] int  NOT NULL
);
GO

-- Creating table 'Users'
CREATE TABLE [dbo].[Users] (
    [Id] int IDENTITY(1,1) NOT NULL,
    [Username] nvarchar(max)  NOT NULL,
    [Password] nvarchar(max)  NOT NULL,
    [UserTypeId] int  NOT NULL
);
GO

-- Creating table 'UserTypes'
CREATE TABLE [dbo].[UserTypes] (
    [Id] int IDENTITY(1,1) NOT NULL,
    [Type] nvarchar(max)  NOT NULL
);
GO

-- --------------------------------------------------
-- Creating all PRIMARY KEY constraints
-- --------------------------------------------------

-- Creating primary key on [Id] in table 'ActionTypes'
ALTER TABLE [dbo].[ActionTypes]
ADD CONSTRAINT [PK_ActionTypes]
    PRIMARY KEY CLUSTERED ([Id] ASC);
GO

-- Creating primary key on [Id] in table 'Incomes'
ALTER TABLE [dbo].[Incomes]
ADD CONSTRAINT [PK_Incomes]
    PRIMARY KEY CLUSTERED ([Id] ASC);
GO

-- Creating primary key on [Id] in table 'Outcomes'
ALTER TABLE [dbo].[Outcomes]
ADD CONSTRAINT [PK_Outcomes]
    PRIMARY KEY CLUSTERED ([Id] ASC);
GO

-- Creating primary key on [Id] in table 'Users'
ALTER TABLE [dbo].[Users]
ADD CONSTRAINT [PK_Users]
    PRIMARY KEY CLUSTERED ([Id] ASC);
GO

-- Creating primary key on [Id] in table 'UserTypes'
ALTER TABLE [dbo].[UserTypes]
ADD CONSTRAINT [PK_UserTypes]
    PRIMARY KEY CLUSTERED ([Id] ASC);
GO

-- --------------------------------------------------
-- Creating all FOREIGN KEY constraints
-- --------------------------------------------------

-- Creating foreign key on [UsersId] in table 'Incomes'
ALTER TABLE [dbo].[Incomes]
ADD CONSTRAINT [FK_UsersIncome]
    FOREIGN KEY ([UsersId])
    REFERENCES [dbo].[Users]
        ([Id])
    ON DELETE NO ACTION ON UPDATE NO ACTION;

-- Creating non-clustered index for FOREIGN KEY 'FK_UsersIncome'
CREATE INDEX [IX_FK_UsersIncome]
ON [dbo].[Incomes]
    ([UsersId]);
GO

-- Creating foreign key on [UsersId] in table 'Outcomes'
ALTER TABLE [dbo].[Outcomes]
ADD CONSTRAINT [FK_UsersOutcome]
    FOREIGN KEY ([UsersId])
    REFERENCES [dbo].[Users]
        ([Id])
    ON DELETE NO ACTION ON UPDATE NO ACTION;

-- Creating non-clustered index for FOREIGN KEY 'FK_UsersOutcome'
CREATE INDEX [IX_FK_UsersOutcome]
ON [dbo].[Outcomes]
    ([UsersId]);
GO

-- Creating foreign key on [UserTypeId] in table 'Users'
ALTER TABLE [dbo].[Users]
ADD CONSTRAINT [FK_UserTypesUsers]
    FOREIGN KEY ([UserTypeId])
    REFERENCES [dbo].[UserTypes]
        ([Id])
    ON DELETE NO ACTION ON UPDATE NO ACTION;

-- Creating non-clustered index for FOREIGN KEY 'FK_UserTypesUsers'
CREATE INDEX [IX_FK_UserTypesUsers]
ON [dbo].[Users]
    ([UserTypeId]);
GO

-- Creating foreign key on [ActionTypeId] in table 'Incomes'
ALTER TABLE [dbo].[Incomes]
ADD CONSTRAINT [FK_ActionTypeIncome]
    FOREIGN KEY ([ActionTypeId])
    REFERENCES [dbo].[ActionTypes]
        ([Id])
    ON DELETE NO ACTION ON UPDATE NO ACTION;

-- Creating non-clustered index for FOREIGN KEY 'FK_ActionTypeIncome'
CREATE INDEX [IX_FK_ActionTypeIncome]
ON [dbo].[Incomes]
    ([ActionTypeId]);
GO

-- Creating foreign key on [ActionTypeId] in table 'Outcomes'
ALTER TABLE [dbo].[Outcomes]
ADD CONSTRAINT [FK_ActionTypeOutcome]
    FOREIGN KEY ([ActionTypeId])
    REFERENCES [dbo].[ActionTypes]
        ([Id])
    ON DELETE NO ACTION ON UPDATE NO ACTION;

-- Creating non-clustered index for FOREIGN KEY 'FK_ActionTypeOutcome'
CREATE INDEX [IX_FK_ActionTypeOutcome]
ON [dbo].[Outcomes]
    ([ActionTypeId]);
GO

-- --------------------------------------------------
-- Script has ended
-- --------------------------------------------------